#include "cmd.h"

///////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////

void cmdDisconnect(){
	online = 0;
	fl_remove_io_callback(s, FL_READ, server_io_handler);
	close(s);

	disableFormObject(button_openRegion);
	disableFormObject(button_openSector);
	disableFormObject(button_openView);
	disableFormObject(button_openUser);
	disableFormObject(button_disconnect);
	fl_delete_object(button_disconnect);
	fl_add_object(window, button_connect);   
	enableFormObject(button_connect);
	fl_deactivate_object(input_servermsg);
	printf("%c", (char)0x7);
}


char *getUsername(unsigned user_id){
	struct structUser *tmp;
	int x;

	tmp = user_db;
	for(x=0; x<nr_users; x++){
		if(tmp->id == user_id) break;
		tmp = tmp->next;
	}
	return(tmp->username);
}


void cmdReceiveMessage(char *data){
	char string[20], out[BUFFER_SIZE];
	unsigned uid;
	unsigned long long os_time;

	sscanf(data, "%s", string);
	data+=strlen(string) + 1;
	sscanf(string, "%Ld", &os_time);

	sscanf(data, "%s", string);
	data+=strlen(string) + 1;
	uid = atoi(string);

	sscanf(data, "%s", string);
	data+=strlen(string) + 1;

	if(!strcmp(string, "0")){
		strcpy(string, "ALL");
	} else if(atoi(string) == client_uid) strcpy(string, "YOU");

	if(uid){
		sprintf(out, "@b%8d\t<%s>(to %s)\t%s", (unsigned)os_time/60, getUsername(uid),
				string, data);
	} else {
		sprintf(out, "@b%8d\t<<%s>>(to %s)\t%s", (unsigned)os_time/60, getUsername(uid),
				string, data);
	}
	fl_addto_browser(listbox_messages, out);
}


void cmdNewUser(char *data){
	struct structUser *tmp;

	tmp = (struct structUser *)malloc(sizeof(struct structUser));

	sscanf(data, "%u %s %u %u %u %u %u %u %u", &(tmp->id), tmp->username, &(tmp->level),
		&(tmp->color1.red), &(tmp->color1.blue), &(tmp->color1.green),
		&(tmp->color2.red), &(tmp->color2.blue), &(tmp->color2.green));


	tmp->newlevel = tmp->level;
	if(user_db==NULL){
		tmp->next = tmp;
		tmp->prev = tmp;
	} else {
		tmp->next = user_db;
		tmp->prev = user_db->prev;
		user_db->prev->next = tmp;
		user_db->prev = tmp;
	}
	user_db = tmp;
	nr_users++;
	if(!strcmp(username, tmp->username)) client_uid = tmp->id;
	if(user_window_open) redrawUserWindow();
}


void cmdObjectUpdate(char *data){
	uint32 object_id, x, y;
	unsigned a;
	float heading;
	struct structObject *tmp;

	sscanf(data, "%u %u %u %f", &object_id, &x, &y, &heading);

	tmp = object_db;
	for(a=0; a<nr_objects; a++){
		if(tmp->id == object_id){
			tmp->x = x; tmp->y = y; tmp->heading = heading;
		}
		tmp = tmp->next;
	}
	redraw_needed = 1;
}


void cmdUserDead(char *data){
}


void cmdObjectShort(char *data){
	int a;
	struct structObject *tmp;

	tmp = (struct structObject *)malloc(sizeof(struct structObject));
	ssscanf(&data, "%u", &(tmp->id));
	ssscanf(&data, "%s", tmp->name);
	ssscanf(&data, "%u", &(tmp->class_id));
	ssscanf(&data, "%u", &(tmp->user_id));
	ssscanf(&data, "%d", &(tmp->velocity));
	ssscanf(&data, "%f", &(tmp->heading));
	ssscanf(&data, "%u", &(tmp->sheilds));
	ssscanf(&data, "%u", &(tmp->fuel));
	ssscanf(&data, "%u", &(tmp->sections));
	ssscanf(&data, "%u", &(tmp->flags));
	ssscanf(&data, "%u", &(tmp->x));
	ssscanf(&data, "%u", &(tmp->y));

	for(a=0; a<16; a++){
		ssscanf(&data, "%u", &(tmp->armor[a]));
	}

	if(object_db==NULL){
                tmp->next = tmp;
                tmp->prev = tmp;
	} else {
                tmp->next = object_db;
                tmp->prev = object_db->prev;
                object_db->prev->next = tmp;
                object_db->prev = tmp;
	}
	object_db = tmp;
	nr_objects++;
	redraw_needed = 1;
}


void cmdObjectLong(char *data){
}


void cmdGetScript(char *data){
}


void cmdObjectDestroyed(char *data){
}


void cmdNewClass2D(char *data){
	int b, c;
	struct structShipClass *tmp;
	struct structPolygon *tmp2;
	struct structWeapon *tmp3;
	uint32 size, size2;

	size = sizeof(struct structShipClass);
	tmp = (struct structShipClass *)malloc(size);

	ssscanf(&data, "%u", &(tmp->id));
	ssscanf(&data, "%s", tmp->name);
	ssscanf(&data, "%u", &(tmp->flags));
	ssscanf(&data, "%u", &(tmp->max_armor));
	ssscanf(&data, "%u", &(tmp->max_sheild));
	ssscanf(&data, "%u", &(tmp->sensor_range));
	ssscanf(&data, "%u", &(tmp->mass));
	ssscanf(&data, "%u", &(tmp->max_fuel));
	ssscanf(&data, "%d", &(tmp->max_fore_velocity));
	ssscanf(&data, "%d", &(tmp->max_aft_velocity));
	ssscanf(&data, "%f", &(tmp->turn_rate));
	ssscanf(&data, "%u", &(tmp->nr_weapons));
	ssscanf(&data, "%u", &(tmp->nr_polygons));

printf("SHAPE: [%s] %u\n", tmp->name, tmp->nr_polygons);
	for(b=0; b<(tmp->nr_polygons); b++){
		if(b>0){
			size += sizeof(struct structPolygon *);
			tmp = (struct structShipClass *)realloc(tmp, size);
		}
		size2 = sizeof(struct structPolygon);
		tmp2 = (struct structPolygon *)malloc(size2);

		ssscanf(&data, "%u", &(tmp2->nr_points));
printf("\t%u", tmp2->nr_points);
		for(c=0; c<(tmp2->nr_points); c++){
			if(c>0){
				size2 += sizeof(struct structXPoint);
				tmp2 = (struct structPolygon *)realloc(tmp2, size2);
			}
			ssscanf(&data, "%d", &(tmp2->points[c].r));
			ssscanf(&data, "%f", &(tmp2->points[c].a));
printf(" (%d %.3f)", tmp2->points[c].r, tmp2->points[c].a);
		}
		tmp->polygons[b] = tmp2;
printf("\n");
	}

	for(b=0; b<(tmp->nr_weapons); b++){
		tmp3 = (struct structWeapon *)malloc(sizeof(struct structWeapon));
		ssscanf(&data, "%s", tmp3->name);
		ssscanf(&data, "%f", &(tmp3->heading));
		ssscanf(&data, "%f", &(tmp3->coverage));
		ssscanf(&data, "%u", &(tmp3->power));
		ssscanf(&data, "%u", &(tmp3->damage));
		ssscanf(&data, "%d", &(tmp3->x));
		ssscanf(&data, "%d", &(tmp3->y));
		if((tmp->weapons) == NULL){
			tmp3->next = tmp3;
			tmp3->prev = tmp3;
		} else {
			tmp3->next = tmp->weapons;
			tmp3->prev = tmp->weapons->prev;
			tmp->weapons->prev->next = tmp3;
			tmp->weapons->prev = tmp3;
		}
		tmp->weapons = tmp3;
	}

	if(shipclass_db==NULL){
		tmp->next = tmp;
		tmp->prev = tmp;
	} else {
		tmp->next = shipclass_db;
		tmp->prev = shipclass_db->prev;
		shipclass_db->prev->next = tmp;
		shipclass_db->prev = tmp;
	}
	shipclass_db = tmp;
	nr_shipclass++;
}


void cmdNewClass3D(char *data){
}
