#include "net.h"

////////////////////////////////////////////////////

struct sockaddr_in server;
struct hostent *res;
unsigned int src;
int s;

////////////////////////////////////////////////////

int serverSend(char *data){
	// returns -1 if failed
	int count;

	count = send(s, data, strlen(data)+1, 0);
#ifdef __DEBUG_CLIENT_NETWORK__
	printf("  client -> server: (%d) %s\n", count, data);
#endif
	return(count);
}


int serverRecv(char *data){
	// returns -1 if failed
	int count; char c[2];

	count=0;
	do{
		if(recv(s, c, 1, 0) < 0){
			printf("Lost connection to server.\n");
			return(-1);
		}
		if(c[0]<32 && c[0]>0){
			printf(":\tlost connection to server\n");
			return(-1);
		}
		data[count]=c[0];
		count++;
	}while(c[0]!='\0' && count<BUFFER_SIZE);
	if(count>1){
#ifdef __DEBUG_CLIENT_NETWORK__
		printf("  server -> client: (%d) %s\n", count, data);
#endif
		return(count);
	}
	printf(":\tgot crap from server\n");
	return(-1);
}


int serverConnect(int connect_type){
	int tries;
	char data[BUFFER_SIZE];

	if((res = gethostbyname(servername)) != NULL)
		memcpy(&src, res->h_addr, res->h_length);
	else if((src = inet_addr(servername)) == -1){
		printf("SERVER CONNECT: Could not resolve hostname.\n");
		return(0);
	}

	tries = 3;
	while(1){
		if((s = socket(AF_INET, SOCK_STREAM, IPPROTO_IP)) < 0){
			printf("SERVER CONNECT: Could not allocate socket.\n");
			return(0);
		}

		memset(&server, 0, sizeof(struct sockaddr_in));
		server.sin_family=AF_INET;
		server.sin_port=htons(serverport);
		server.sin_addr.s_addr=src;
		bzero(&(server.sin_zero), 8);

		if(connect(s, (struct sockaddr *)&server, sizeof(server)) == 0) break;

		close(s);
		tries--;
		if(tries==0){
			printf("SERVER CONNECT: Connect failed.\n");
			return(0);
		} else printf("SERVER CONNECT: Connect failed, retrying...\n");
	}

	printf("SERVER CONNECT: Connected to server, logging in...\n");

	sprintf(data, "%c%s %s", (char)connect_type, username, password);
	serverSend(data);

	if(serverRecv(data) != -1){
		if(data[0] == (char)CMD__CONNECTED){
			online = 1;

			sscanf(data, "%Ld %d %d %d %d", &connected_vm_time, &connected_local_players,
				&connected_servers, &connected_players, &timeout_value);

printf("CONNECTED: server time = %Ld , local players = %d , servers = %d , total players = %d\n",
	connected_vm_time, connected_local_players, connected_servers, connected_players);

			if(connect_type == CMD_NEW){
				// create config file
				valid_config = 1;
				return(1);
			} else return(1);
		}
		printf("SERVER CONNECT: username/password incorrect or exists.\n");
	}
	return(0);
}

