#include "ui.h"

///////////////////////////////////////////////////////////////////////

FL_FORM *window, *window_region, *window_sector, *window_view, *window_users;
FL_OBJECT *button_openRegion, *button_openSector, *button_openView, *button_openUser;
FL_OBJECT *button_closeRegion, *button_closeSector, *button_closeView;
FL_OBJECT *button_newuser, *button_connect, *button_disconnect, *button_quit;
FL_OBJECT *listbox_messages, *input_servermsg;

FL_OBJECT *button_u_update, *button_u_close, *listbox_u_users;
FL_OBJECT *canvas_region, *canvas_sector, *canvas_view;

uint8 user_window_open, region_window_open, sector_window_open, view_window_open, redraw_needed;
uint32 view_x, view_y, view_w, view_h, view_zoom, view_zoom2, sector_x, sector_y;
int timeoutid_region, timeoutid_sector, timeoutid_view, timeout_value;
struct structObject *view_tracks_object;

XPoint xp_stars[50];

char *vz_text[9] = { "#----", "", "-#---", "", "--#--", "", "---#-", "", "----#" };

///////////////////////////////////////////////////////////////////////

void quit( ){
	char out[2];

	out[0] = (char)CMD_DISCONNECT; out[1] = '\0';
	if(online) serverSend(out);
	saveConfig();
	exit(EXIT_SUCCESS);
}


void openRegionWindow(){
	fl_hide_object(button_openRegion);
	fl_show_object(button_closeRegion);

	if(window_region == NULL){
		window_region = fl_bgn_form(FL_FLAT_BOX, 266, 266);
		fl_add_box(FL_FLAT_BOX,         0, 0, 266, 266, "");

		canvas_region = fl_add_canvas(FL_NORMAL_CANVAS, 5, 5, 256, 256, "");
		fl_add_canvas_handler(canvas_region, Expose, exposeRegionWindow, NULL);
		fl_add_canvas_handler(canvas_region, ButtonPress, focusSectorWindow, NULL);

		fl_end_form();
	}
	fl_show_form(window_region, FL_PLACE_MOUSE, FL_FULLBORDER, WINDOW_NAME_REGION);
	redrawRegionWindow();
	timeoutid_region = fl_add_timeout(timeout_value/2, timerRegionWindow, NULL);
	region_window_open = 1;
}


void openSectorWindow(){
	fl_hide_object(button_openSector);
	fl_show_object(button_closeSector);

	if(window_sector == NULL){
		window_sector = fl_bgn_form(FL_FLAT_BOX, 266, 266);
		fl_add_box(FL_FLAT_BOX,         0, 0, 266, 266, "");

		canvas_sector = fl_add_canvas(FL_NORMAL_CANVAS, 5, 5, 256, 256, "");
		fl_add_canvas_handler(canvas_sector, Expose, exposeSectorWindow, NULL);
		fl_add_canvas_handler(canvas_sector, ButtonPress, focusViewWindow, NULL);

		fl_end_form();
	}
	fl_show_form(window_sector, FL_PLACE_MOUSE, FL_FULLBORDER, WINDOW_NAME_SECTOR); 
	redrawSectorWindow();
	timeoutid_sector = fl_add_timeout(timeout_value/2, timerSectorWindow, NULL);
	sector_window_open = 1;
}


void openViewWindow(){
	int a;

	fl_hide_object(button_openView);
	fl_show_object(button_closeView);

	if(window_view == NULL){
		window_view = fl_bgn_form(FL_FLAT_BOX, 522, 522);
		fl_add_box(FL_FLAT_BOX,           0, 0, 522, 522, "");

		canvas_view = fl_add_canvas(FL_NORMAL_CANVAS, 5, 5, view_w, view_h, "");
		fl_add_canvas_handler(canvas_view, Expose, exposeViewWindow, NULL);
		fl_add_canvas_handler(canvas_view, ButtonPress, dragViewWindow, NULL);
		fl_add_canvas_handler(canvas_view, ButtonRelease, releaseViewWindow, NULL);
		fl_add_canvas_handler(canvas_view, KeyPress, keyViewWindow, NULL);

		srand(time(0));
		for(a=0; a<50; a++){
			xp_stars[a].x = 1 + (int)((float)view_w*rand()/(RAND_MAX+1.0));
			xp_stars[a].y = 1 + (int)((float)view_h*rand()/(RAND_MAX+1.0));
		}
		fl_end_form();
	}
	
	fl_show_form(window_view, FL_PLACE_MOUSE, FL_FULLBORDER, WINDOW_NAME_VIEW);
	redrawViewWindow(0,0);
	timeoutid_view = fl_add_timeout(timeout_value >> 1, timerViewWindow, NULL);
	view_window_open = 1;
}


int exposeRegionWindow(FL_OBJECT *ob, Window win, int win_width, int win_height, XEvent *xev, void *user_data){
	redrawRegionWindow();
	return(0);
}
int exposeSectorWindow(FL_OBJECT *ob, Window win, int win_width, int win_height, XEvent *xev, void *user_data){
	redrawSectorWindow();
	return(0);
}
int exposeViewWindow(FL_OBJECT *ob, Window win, int win_width, int win_height, XEvent *xev, void *user_data){
	redrawViewWindow(0,0);
	return(0);
}
int focusSectorWindow(FL_OBJECT *ob, Window win, int win_width, int win_height, XEvent *xev, void *user_data){
	uint32 x, y;

	x = xev->xbutton.x-4; if(x>255){ x = 0; } if(x>248) x = 248;
	y = xev->xbutton.y-4; if(y>255){ y = 0; } if(y>248) y = 248;
	sector_x = view_x = x << 24;
	sector_y = view_y = y << 24;
	if(region_window_open) redrawRegionWindow();
	if(sector_window_open) redrawSectorWindow();
	return(0);
}
int focusViewWindow(FL_OBJECT *ob, Window win, int win_width, int win_height, XEvent *xev, void *user_data){
	uint32 x, y;

	x = xev->xbutton.x-4; if(x>255){ x = 0; } if(x>248) x = 248;
	y = xev->xbutton.y-4; if(y>255){ y = 0; } if(y>248) y = 248;
	view_x = sector_x + (x << 19);
	view_y = sector_y + (y << 19);
	if(sector_window_open) redrawSectorWindow();
	if(view_window_open) redrawViewWindow(0,0);
	return(0);
}
int dragViewWindow(FL_OBJECT *ob, Window win, int win_width, int win_height, XEvent *xev, void *user_data){
	printf("click\n");
	return(0);
}
int releaseViewWindow(FL_OBJECT *ob, Window win, int win_width, int win_height, XEvent *xev, void *user_data){ 
	printf("click release\n");
	return(0);
}
int keyViewWindow(FL_OBJECT *ob, Window win, int win_width, int win_height, XEvent *xev, void *user_data){
	uint32 old_x, old_y;
	int sx, sy;

	sx = 0; sy = 0;
	if(xev->xkey.keycode == KEY_DOWN){
		sy = -1;
		old_y = view_y;
		view_y += SCROLL_VALUE << view_zoom;
		if((view_y + (view_h << view_zoom)) > (0xffffffff - (view_h << view_zoom))){
			view_y = 0xffffffff - (view_h << view_zoom); fl_ringbell(0); sy = 0; }
		if(view_y < old_y){ view_y = 0xffffffff - (view_h << view_zoom); fl_ringbell(0);
			sy = 0; }
	} else if(xev->xkey.keycode == KEY_UP){
		sy = 1;
		old_y = view_y;
		view_y -= (SCROLL_VALUE << view_zoom);
		if(view_y > old_y){ view_y = 0; fl_ringbell(0); sy = 0; }
	} else if(xev->xkey.keycode == KEY_RIGHT){
		sx = -1;
		old_x = view_x;
		view_x += (SCROLL_VALUE << view_zoom);
		if((view_x + (view_w << view_zoom)) > (0xffffffff - (view_w << view_zoom))){
			view_x = 0xffffffff - (view_w << view_zoom); fl_ringbell(0); sx = 0; }
		if(view_x < old_x){ view_x = 0xffffffff - (view_w << view_zoom); fl_ringbell(0);
			sx = 0; }
	} else if(xev->xkey.keycode == KEY_LEFT){
		sx = 1;
		old_x = view_x;
		view_x -= (SCROLL_VALUE << view_zoom);
		if(view_x > old_x){ view_x = 0; fl_ringbell(0); sx = 0; }
	} else if(xev->xkey.keycode == KEY_MINUS){
		// zoom out
		old_x = view_x; old_y = view_y;
		view_x -= view_w << (view_zoom - 1); view_y -= view_h << (view_zoom - 1);
		view_zoom += 3;
		view_zoom2 += 2;
		if(view_zoom > MAX_ZOOM){ view_zoom = MAX_ZOOM; fl_ringbell(0); }
		if(view_zoom2 > MAX_ZOOM2){ view_zoom2 = MAX_ZOOM2; fl_ringbell(0); }

		if((view_x + (view_w << view_zoom)) > (0xffffffff - (view_w << view_zoom))){
			view_x = 0xffffffff - (view_w << view_zoom); fl_ringbell(0); }
		if(view_x > old_x){ view_x = 0; fl_ringbell(0); }
		if((view_y + (view_h << view_zoom)) > (0xffffffff - (view_w << view_zoom))){
			view_y = 0xffffffff - (view_h << view_zoom); fl_ringbell(0); }
		if(view_y > old_y){ view_y = 0; fl_ringbell(0); }
	} else if(xev->xkey.keycode == KEY_PLUS){
		// zoom in
		old_x = view_x; old_y = view_y;
		view_x += view_w << (view_zoom - 2); view_y += view_h << (view_zoom - 2);
		view_zoom -= 3;
		view_zoom2 -= 2;
		if((view_zoom < 1) || (view_zoom > MAX_ZOOM)){ view_zoom = 1; fl_ringbell(0); }
		if((view_zoom2 < 1) || (view_zoom2 > MAX_ZOOM2)){ view_zoom2 = 1; fl_ringbell(0); }
	}

	if( (sx != 0) || (sy != 0) ){
if(view_tracks_object != NULL) printf("FOLLOW MODE INACTIVE FOR %s\n", view_tracks_object->name);
		view_tracks_object = NULL;
	}
	if(region_window_open) redrawRegionWindow();
	if(sector_window_open) redrawSectorWindow();
	redrawViewWindow(sx, sy);
	return(0);
}


void timerRegionWindow(int timeout_id, void *data){
	if(redraw_needed) redrawRegionWindow();
	timeoutid_region = fl_add_timeout(timeout_value/2, timerRegionWindow, NULL);
}
void timerSectorWindow(int timeout_id, void *data){
	if(redraw_needed) redrawSectorWindow();
	timeoutid_sector = fl_add_timeout(timeout_value/2, timerSectorWindow, NULL);
}
void timerViewWindow(int timeout_id, void *data){
	if(redraw_needed) redrawViewWindow(0,0);
	timeoutid_view = fl_add_timeout(timeout_value/2, timerViewWindow, NULL);
}


void redrawRegionWindow(){
	int a;
	struct structObject *tmp;

	GC gc = fl_state[fl_get_vclass()].gc[0];
	Window win = FL_ObjWin(canvas_region);
	Display *disp = fl_get_display();

	XSetForeground(disp, gc, fl_get_pixel(COLOR_BACKGROUND));
	XFillRectangle(disp, win, gc, 0, 0, 256, 256);

	XSetForeground(disp, gc, fl_get_pixel(COLOR_MARQUE));
	XDrawRectangle(disp, win, gc, sector_x>>24,sector_y>>24, 8,8);

	tmp = object_db;
	for(a=0; a<nr_objects; a++){
		XSetForeground(disp, gc, fl_get_pixel(COLOR_PLAYER));
		XDrawPoint(disp, win, gc, (tmp->x)>>24, (tmp->y)>>24);
		tmp = tmp->next;
	}
}
void redrawSectorWindow(){
	int a;
	struct structObject *tmp;

	GC gc = fl_state[fl_get_vclass()].gc[0];
	Window win = FL_ObjWin(canvas_sector);
	Display *disp = fl_get_display();

	XSetForeground(disp, gc, fl_get_pixel(COLOR_BACKGROUND));
	XFillRectangle(disp, win, gc, 0, 0, 256, 256);

	XSetForeground(disp, gc, fl_get_pixel(COLOR_MARQUE));
	XDrawRectangle(disp, win, gc, (view_x>>19)&0xff,(view_y>>19)&0xff, 8,8);

	tmp = object_db;
	for(a=0; a<nr_objects; a++){
		XSetForeground(disp, gc, fl_get_pixel(COLOR_PLAYER));
		if(	(tmp->x >= sector_x) && (tmp->x <= sector_x + 0x07ffffff) &&
			(tmp->y >= sector_y) && (tmp->y <= sector_y + 0x07ffffff)
		){
			XDrawPoint(disp, win, gc, ((tmp->x)>>19)&0xff, ((tmp->y)>>19)&0xff);
		}
		tmp = tmp->next;
	}
}
void redrawViewWindow(int sx, int sy){
	int a, b, c;
	uint32 old_x, old_y;
	char string[20];
	struct structObject *tmp;
	struct structShipClass *class;
	XPoint xp_polygon[MAX_POLYGON_POINTS];

	GC gc = fl_state[fl_get_vclass()].gc[0];
	Window win = FL_ObjWin(canvas_view);
	Display *disp = fl_get_display();

	if(view_tracks_object != NULL){
//printf("FOLLOWING %s\n", view_tracks_object->name);
		old_x = view_x; old_y = view_y;
		view_x = view_tracks_object->x - (view_w << (view_zoom - 1));
		view_y = view_tracks_object->y - (view_h << (view_zoom - 1));
		if(view_x > old_x) sx = -1;
		if(view_x < old_x) sx = 1;
		if(view_y > old_y) sx = -1;
		if(view_y < old_y) sx = 1;
	}


	XSetForeground(disp, gc, fl_get_pixel(COLOR_BACKGROUND));
	XFillRectangle(disp, win, gc, 0, 0, view_w, view_h);

	// display stars
	for(a=0; a<25; a++){
		xp_stars[a].x += sx; xp_stars[a].y += sy;
		if(xp_stars[a].x < 0) xp_stars[a].x = view_w;
		if(xp_stars[a].x > view_w) xp_stars[a].x = 0;
		if(xp_stars[a].y < 0) xp_stars[a].y = view_h;
		if(xp_stars[a].y > view_h) xp_stars[a].y = 0;
		XSetForeground(disp, gc, fl_get_pixel(COLOR_STARS1));
		XDrawPoint(disp, win, gc, xp_stars[a].x, xp_stars[a].y);
	}
	for(a=26; a<50; a++){
                xp_stars[a].x += sx; xp_stars[a].y += sy;
                if(xp_stars[a].x < 0) xp_stars[a].x = view_w;
                if(xp_stars[a].x > view_w) xp_stars[a].x = 0;
                if(xp_stars[a].y < 0) xp_stars[a].y = view_h;
                if(xp_stars[a].y > view_h) xp_stars[a].y = 0;
		XSetForeground(disp, gc, fl_get_pixel(COLOR_STARS2));
		XDrawPoint(disp, win, gc, xp_stars[a].x, xp_stars[a].y);
	}

//printf("view(%u,%u) zoom(%u/%u) \n", view_x, view_y, view_zoom, view_zoom2);
	tmp = object_db;
	for(a=0; a<nr_objects; a++){
//printf("\tdraw ship [%s] (%u,%u)\n", tmp->name, tmp->x, tmp->y);
		class = shipclassFindByID(tmp->class_id);
		for(b=0; b<(class->nr_polygons); b++){
//printf("\t%d ", class->polygons[b]->nr_points);
		   for(c=0; c<(class->polygons[b]->nr_points); c++){
			xp_polygon[c].x = (int)((class->polygons[b]->points[c].r << view_zoom2) *
			cos(class->polygons[b]->points[c].a - tmp->heading) + tmp->x - view_x) >>
			view_zoom;
			xp_polygon[c].y = (int)((class->polygons[b]->points[c].r << view_zoom2) *
			sin(class->polygons[b]->points[c].a - tmp->heading) + tmp->y - view_y) >>
			view_zoom;
//printf(" (%d,%d)[%d@%.1f]", xp_polygon[c].x, xp_polygon[c].y, class->polygons[b]->points[c].r,
//	class->polygons[b]->points[c].a);
		   }
//printf("\n");
		   XSetForeground(disp, gc, fl_get_pixel(FL_SLATEBLUE));
		   XFillPolygon(disp, win, gc, xp_polygon, c, Nonconvex, Unsorted);
		}
		tmp = tmp->next;
//printf("\n");
	}
	sprintf(string, "IN %s OUT", vz_text[view_zoom2 - 1]);
	XSetForeground(disp, gc, fl_get_pixel(COLOR_MARQUE));
	XSetBackground(disp, gc, fl_get_pixel(COLOR_BACKGROUND));
	XDrawImageString(disp, win, gc, 5, view_h - 5, string, strlen(string));
}


void closeRegionWindow(){
	region_window_open = 0;
	fl_remove_timeout(timeoutid_region);
	fl_hide_form(window_region);
	fl_hide_object(button_closeRegion);
	fl_show_object(button_openRegion);
}
void closeSectorWindow(){
	sector_window_open = 0;
        fl_remove_timeout(timeoutid_sector); 
        fl_hide_form(window_sector); 
        fl_hide_object(button_closeSector); 
        fl_show_object(button_openSector); 
}
void closeViewWindow(){
	view_window_open = 0;
	fl_remove_timeout(timeoutid_view);
        fl_hide_form(window_view);
	fl_hide_object(button_closeView);
        fl_show_object(button_openView);
}
void closeUserWindow(){
	fl_hide_form(window_users);
	enableFormObject(button_openUser);
}


void openUserWindow(){
	disableFormObject(button_openUser);

	if(window_users == NULL){
		window_users = fl_bgn_form(FL_FLAT_BOX, 310, 300);

		listbox_u_users = fl_add_browser(FL_HOLD_BROWSER,      5,  5, 300, 260, NULL);
		fl_set_object_lstyle(listbox_u_users, FL_FIXED_STYLE);
		fl_set_object_gravity(listbox_u_users, FL_NorthWest, FL_SouthEast);
		fl_set_object_resize(listbox_u_users, FL_RESIZE_ALL);
		fl_set_browser_dblclick_callback(listbox_u_users, userChangeLevels, 0);

		button_u_update = fl_add_button(FL_NORMAL_BUTTON,        5, 270,  60, 25, "Update");
		fl_set_object_lstyle(button_u_update, FL_BOLD_STYLE);
		fl_set_object_gravity(button_u_update, FL_SouthWest, FL_SouthWest);
		fl_set_object_resize(button_u_update, FL_RESIZE_NONE);

		button_u_close = fl_add_button(FL_NORMAL_BUTTON,        260, 270,  45, 25, "Close");
		fl_set_object_lstyle(button_u_close, FL_BOLD_STYLE);
		fl_set_object_gravity(button_u_close, FL_SouthEast, FL_SouthEast);
		fl_set_object_resize(button_u_close, FL_RESIZE_NONE);

		fl_end_form();
	}
	redrawUserWindow();
	fl_show_form(window_users, FL_PLACE_MOUSE|FL_FREE_SIZE, FL_FULLBORDER, WINDOW_NAME);
	user_window_open = 1;
}


void redrawUserWindow(){
	struct structUser *tmp;
	int x;
	char out[100], level[10], newlevel[10];

	fl_clear_browser(listbox_u_users);
	sprintf(out, "@bUID\tCURRENT\tCHANGED\tUSERNAME\n");
	fl_add_browser_line(listbox_u_users, out);
	tmp = user_db;
	for(x=0; x<nr_users; x++){
		if(tmp->id != client_uid){
		if(tmp->level==0) strcpy(level, "unknown");
		if(tmp->level==1) strcpy(level, "neutral");
		if(tmp->level==2) strcpy(level, "ally");
		if(tmp->level==3) strcpy(level, "enemy");
		if(tmp->newlevel==0) strcpy(newlevel, "unknown");
		if(tmp->newlevel==1) strcpy(newlevel, "neutral");
		if(tmp->newlevel==2) strcpy(newlevel, "ally");
		if(tmp->newlevel==3) strcpy(newlevel, "enemy");
		} else {
			strcpy(level, "YOU");
			strcpy(newlevel, "*");
		}
		sprintf(out, "@b%d\t%s\t\t%s\t\t%s", tmp->id, level, newlevel, tmp->username);
		fl_add_browser_line(listbox_u_users, out);

		tmp = tmp->next;
	}
}


void processMessage(){
	char out[BUFFER_SIZE], string[20], *input;
	struct structObject *tmp;
	struct structUser *tmp2;
	int a;

	input = (char *)fl_get_input(input_servermsg);

	if(*input == '/'){
		input++;
		sscanf(input, "%s", string);
		input+=strlen(string) + 1;
		if(!strcmp(string, "all") || !strcmp(string, "ALL")){
			sprintf(out, "%c0 %s", (char)CMD_MSG, input);
			strcpy(string, "ALL");
		} else {
			tmp2 = userFindByName(string);
			if(tmp2 == NULL){
				sprintf(out, "ERROR: <%s> IS NOT A VALID USERNAME", string);  
				fl_addto_browser(listbox_messages, out);
				fl_set_input(input_servermsg, NULL);
				return;
			}
			sprintf(out, "%c%d %s", (char)CMD_MSG, tmp2->id, input);
		}
	} else if(*input == '\\'){
		input ++;
		if(*input == 'g'){
			a = 0;
			sscanf(input, "g %s", string);
			tmp = object_db;
			for(a=0; a<nr_objects; a++){
				if(!strcmp(tmp->name, string)){
					view_x = tmp->x - (view_w << (view_zoom - 1));
					view_y = tmp->y - (view_h << (view_zoom - 1));
					break;
				}
				tmp = tmp->next;
			}
		} else if(*input == 'f'){
			sscanf(input, "f %s", string);
			tmp = object_db;
			for(a=0; a<nr_objects; a++){
				if(!strcmp(tmp->name, string)){
					printf("FOLLOW MODE ACTIVE FOR %s\n", string);
					view_tracks_object = tmp;
					break;
				}
				tmp = tmp->next;
			}
		} else if(*input == 's'){
			printf("FOLLOW MODE INACTIVE FOR %s\n", view_tracks_object->name);
			view_tracks_object = NULL;
		}
		if(view_window_open) redrawViewWindow(0,0);
		fl_set_input(input_servermsg, NULL);
		return;
	} else {
		sprintf(out, "%c1 %s", (char)CMD_MSG, input);
		strcpy(string, "ALLIES");
	}
	serverSend(out);

	sprintf(out, "\t->%s  %s", string, input);
	fl_addto_browser(listbox_messages, out);
	fl_set_input(input_servermsg, NULL);
}


void openNewUserWindow(){
	FL_FORM *window_newuser;
	FL_OBJECT *button_nw_close, *button_nw_create, *input_nw_server;
	FL_OBJECT *input_nw_username, *input_nw_password, *event, *input_nw_port;
	FILE *config;

	disableFormObject(button_newuser);

	window_newuser = fl_bgn_form(FL_FLAT_BOX, 200, 150);

	fl_add_text(FL_NORMAL_TEXT,                             5,  5,  60,  25, "Server");
	input_nw_server = fl_add_input(FL_NORMAL_INPUT,        65,  5, 130,  25, NULL);
	fl_set_input_maxchars(input_nw_server, 50);
	fl_set_object_lstyle(input_nw_server, FL_BOLD_STYLE);

	fl_add_text(FL_NORMAL_TEXT,                             5, 30,  60,  25, "Port");
	input_nw_port = fl_add_input(FL_INT_INPUT,             65, 30, 130,  25, NULL);
	fl_set_input_maxchars(input_nw_port, 4);
	fl_set_object_lstyle(input_nw_port, FL_BOLD_STYLE);

	fl_add_text(FL_NORMAL_TEXT,                             5, 60,  60,  25, "Username");
	input_nw_username = fl_add_input(FL_NORMAL_INPUT,      65, 60, 130,  25, NULL);
	fl_set_input_maxchars(input_nw_username, 16);
	fl_set_object_lstyle(input_nw_username, FL_BOLD_STYLE);

	fl_add_text(FL_NORMAL_TEXT,                             5, 90,  60,  25, "Password");
	input_nw_password = fl_add_input(FL_NORMAL_INPUT,      65, 90, 130,  25, NULL);
	fl_set_input_maxchars(input_nw_password, 16);
	fl_set_object_lstyle(input_nw_password, FL_BOLD_STYLE);

	button_nw_create = fl_add_button(FL_NORMAL_BUTTON,      5, 120, 100, 25, "Create Account");
	button_nw_close = fl_add_button(FL_NORMAL_BUTTON,     155, 120,  40, 25, "Close");
	fl_set_object_lstyle(button_nw_create, FL_BOLD_STYLE);
	fl_set_object_lstyle(button_nw_close, FL_BOLD_STYLE);
	fl_set_object_lcol(button_nw_close, FL_RED);

	fl_end_form();
	fl_show_form(window_newuser, FL_PLACE_MOUSE, FL_FULLBORDER, WINDOW_NAME);

	do{
		event = fl_do_forms();

		if(event==button_nw_close){
			enableFormObject(button_newuser);
			fl_hide_form(window_newuser);
			return;
		}
		if(event==button_nw_create){
			strcpy(username, fl_get_input(input_nw_username));
			strcpy(password, fl_get_input(input_nw_password));
			strcpy(servername, fl_get_input(input_nw_server));
			serverport = atoi(fl_get_input(input_nw_port));
			if(serverConnect(CMD_NEW)){
				fl_hide_form(window_newuser);
				enableFormObject(button_disconnect);
				enableFormObject(button_openRegion);
				enableFormObject(button_openSector);
				enableFormObject(button_openView);
				enableFormObject(button_openUser);
				fl_activate_object(input_servermsg);
				online = 1;
				fl_add_io_callback(s, FL_READ, server_io_handler, NULL);

				if((config=fopen(CONFIG_PATH, "w")) == NULL){
					printf("Unable to open config for writing, not saved.\n");
					return;
				}
				fprintf(config, "=%s =%s =%s =%d\n", username, password,
					servername, serverport);
				return;
			} else {
				fl_ringbell(0);
			}
		}
	}while(1);
}


void disableFormObject(FL_OBJECT *object){
	fl_deactivate_object(object);
	fl_set_object_lcol(object, FL_BOTTOM_BCOL);
}


void enableFormObject(FL_OBJECT *object){
	fl_activate_object(object);
	fl_set_object_lcol(object, FL_BLACK);
}


void uiInit(int argc, char *argv[]){
	struct structUser *tmp, *tmp2;
	FL_OBJECT *event;
	char out[2];
	int x;

	fl_initialize(&argc, argv, WINDOW_NAME, 0, 0);
	window_users = NULL; window_region = NULL; window_sector = NULL; window_view = NULL;
	view_x = 0; view_y = 0; view_w = 512; view_h = 512;
	view_zoom = MAX_ZOOM; view_zoom2 = MAX_ZOOM2;
	region_window_open = 0; sector_window_open = 0; view_window_open = 0; user_window_open = 0;
	sector_x = 0; sector_y = 0;
	view_tracks_object = NULL;

	window = fl_bgn_form(FL_FLAT_BOX, 640, 220);

	button_openRegion = fl_add_button(FL_NORMAL_BUTTON,    5, 5,  90, 25, "Open Region");
	button_closeRegion = fl_add_button(FL_NORMAL_BUTTON,   5, 5,  90, 25, "Close Region");
	button_openSector = fl_add_button(FL_NORMAL_BUTTON,   95, 5,  90, 25, "Open Sector");
	button_closeSector = fl_add_button(FL_NORMAL_BUTTON,  95, 5,  90, 25, "Close Sector");
	button_openView = fl_add_button(FL_NORMAL_BUTTON,    185, 5, 100, 25, "Open ViewArea");
	button_closeView = fl_add_button(FL_NORMAL_BUTTON,   185, 5, 100, 25, "Close ViewArea");
	button_openUser = fl_add_button(FL_NORMAL_BUTTON,    290, 5,  90, 25, "Player List");
	button_newuser = fl_add_button(FL_NORMAL_BUTTON,     385, 5,  80, 25, "New User");
	button_connect = fl_add_button(FL_NORMAL_BUTTON,     465, 5,  65, 25, "Connect");
	button_disconnect = fl_add_button(FL_NORMAL_BUTTON,  465, 5,  75, 25, "Disconnect");
	button_quit = fl_add_button(FL_NORMAL_BUTTON,        595, 5,  40, 25, "Quit");
	fl_set_object_lstyle(button_openRegion, FL_BOLD_STYLE);
	fl_set_object_lstyle(button_closeRegion, FL_BOLD_STYLE);
	fl_set_object_lstyle(button_openSector, FL_BOLD_STYLE);
	fl_set_object_lstyle(button_closeSector, FL_BOLD_STYLE);
	fl_set_object_lstyle(button_openView, FL_BOLD_STYLE);
	fl_set_object_lstyle(button_closeView, FL_BOLD_STYLE);
	fl_set_object_lstyle(button_openUser, FL_BOLD_STYLE);
	fl_set_object_lstyle(button_newuser, FL_BOLD_STYLE);
	fl_set_object_lstyle(button_connect, FL_BOLD_STYLE);
	fl_set_object_lstyle(button_disconnect, FL_BOLD_STYLE);
	fl_set_object_lstyle(button_quit, FL_BOLD_STYLE);
	fl_set_object_lcol(button_quit, FL_RED);
	fl_set_object_gravity(button_openRegion, FL_NorthWest, FL_NorthWest);
	fl_set_object_gravity(button_closeRegion, FL_NorthWest, FL_NorthWest);
	fl_set_object_gravity(button_openSector, FL_NorthWest, FL_NorthWest);
	fl_set_object_gravity(button_closeSector, FL_NorthWest, FL_NorthWest);
	fl_set_object_gravity(button_openView, FL_NorthWest, FL_NorthWest);
	fl_set_object_gravity(button_closeView, FL_NorthWest, FL_NorthWest);
	fl_set_object_gravity(button_openUser, FL_NorthWest, FL_NorthWest);
	fl_set_object_gravity(button_newuser, FL_NorthWest, FL_NorthWest);
	fl_set_object_gravity(button_connect, FL_NorthWest, FL_NorthWest);
	fl_set_object_gravity(button_disconnect, FL_NorthWest, FL_NorthWest);
	fl_set_object_gravity(button_quit, FL_NorthEast, FL_NorthEast);
	fl_set_object_resize(button_openRegion, FL_RESIZE_NONE);
	fl_set_object_resize(button_closeRegion, FL_RESIZE_NONE);
	fl_set_object_resize(button_openSector, FL_RESIZE_NONE);
	fl_set_object_resize(button_closeSector, FL_RESIZE_NONE);
	fl_set_object_resize(button_openView, FL_RESIZE_NONE);
	fl_set_object_resize(button_closeView, FL_RESIZE_NONE);
	fl_set_object_resize(button_openUser, FL_RESIZE_NONE);
	fl_set_object_resize(button_newuser, FL_RESIZE_NONE);
	fl_set_object_resize(button_connect, FL_RESIZE_NONE);
	fl_set_object_resize(button_disconnect, FL_RESIZE_NONE);
	fl_set_object_resize(button_quit, FL_RESIZE_NONE);

	fl_hide_object(button_closeRegion);
	fl_hide_object(button_closeSector);
	fl_hide_object(button_closeView);

	listbox_messages = fl_add_browser(FL_HOLD_BROWSER,      5,  35, 630, 150, NULL);
	fl_set_object_lstyle(listbox_messages, FL_FIXED_STYLE);
	fl_set_object_gravity(listbox_messages, FL_NorthWest, FL_SouthEast);
	fl_set_object_resize(listbox_messages, FL_RESIZE_ALL);

	input_servermsg = fl_add_input(FL_NORMAL_INPUT,         5, 190, 630,  25, NULL);
	fl_set_input_maxchars(input_servermsg, 150);
	fl_set_object_lstyle(input_servermsg, FL_BOLD_STYLE);
	fl_set_input_return(input_servermsg, FL_RETURN_END);
	fl_set_object_callback(input_servermsg, processMessage, 0);
	fl_set_object_gravity(input_servermsg, FL_West, FL_SouthEast);
	fl_set_object_resize(input_servermsg, FL_RESIZE_X);

	fl_end_form();
	if(online){
                disableFormObject(button_connect);
                fl_delete_object(button_connect);
                disableFormObject(button_newuser);
		fl_add_io_callback(s, FL_READ, server_io_handler, NULL);
	} else {
                disableFormObject(button_openRegion);
		disableFormObject(button_openSector);
                disableFormObject(button_openView);
                disableFormObject(button_openUser);
                disableFormObject(button_connect);
		fl_delete_object(button_connect);
		disableFormObject(button_disconnect);
		fl_deactivate_object(input_servermsg);
	}
	fl_show_form(window, FL_PLACE_MOUSE|FL_FREE_SIZE, FL_FULLBORDER, WINDOW_NAME);
	do{
		event = fl_do_forms();

		if(event==button_u_close)		closeUserWindow();
		else if(event==button_u_update)		userUpdateLevels();

		else if(event==button_openRegion)	openRegionWindow();
		else if(event==button_closeRegion)	closeRegionWindow();
		else if(event==button_openSector)	openSectorWindow();
		else if(event==button_closeSector)	closeSectorWindow();
		else if(event==button_openView)		openViewWindow();
		else if(event==button_closeView)	closeViewWindow();

		else if(event==button_openUser)		openUserWindow();
		else if(event==button_newuser)		openNewUserWindow();
		else if(event==button_connect){
			if(serverConnect(CMD_RESUME)){
				tmp = user_db;
				for(x=0; x<nr_users; x++){
					tmp2 = tmp->next;
					free(tmp);
					tmp = tmp2;
				}
				nr_users = 0;
				user_db = NULL;

				enableFormObject(button_openRegion);
				enableFormObject(button_openSector);
	                        enableFormObject(button_openView); 
	                        enableFormObject(button_openUser);   
	                        enableFormObject(button_connect); 
	                        fl_delete_object(button_connect);  
	                        fl_add_object(window, button_disconnect);
	                        enableFormObject(button_disconnect);
	                        fl_activate_object(input_servermsg);
				if(user_window_open) redrawUserWindow();

				online = 1;
				fl_add_io_callback(s, FL_READ, server_io_handler, NULL);
			} else fl_ringbell(0);
		}
		else if(event==button_disconnect){
			online = 0;
			fl_remove_io_callback(s, FL_READ, server_io_handler);
			out[0] = CMD_DISCONNECT; out[1] = '\0';
			serverSend(out);
			close(s);

	                disableFormObject(button_openRegion);
			disableFormObject(button_openSector);
	                disableFormObject(button_openView);
	                disableFormObject(button_openUser);
	                disableFormObject(button_disconnect);
	                fl_delete_object(button_disconnect);
			fl_add_object(window, button_connect);
			enableFormObject(button_connect);
	                fl_deactivate_object(input_servermsg);
		}
		else if(event==button_quit)			quit();
	}while(1);
}
