#include "global.h"
#ifndef __UI_HEADER__
#define __UI_HEADER__


#define COLOR_BACKGROUND	FL_BLACK
#define COLOR_MARQUE		FL_BOTTOM_BCOL
#define COLOR_STARS1		FL_INACTIVE_COL
#define COLOR_STARS2		FL_DARKCYAN

#define COLOR_PLAYER		FL_GREEN
#define COLOR_ALLY		FL_GREEN
#define COLOR_NEUTRAL		FL_MCOL
#define COLOR_UNKNOWN		FL_YELLOW
#define COLOR_ENENY		FL_RED
#define COLOR_PLANET		FL_BLUE

#define KEY_RIGHT		0x66
#define KEY_LEFT		0x64
#define KEY_UP			0x62
#define KEY_DOWN		0x68
#define KEY_PLUS		0x56
#define KEY_MINUS		0x52

#define SCROLL_VALUE		64
#define MAX_ZOOM		13
#define MAX_ZOOM2		9
#define MAX_POLYGON_POINTS	100

////////////////////////////////////////////////

extern FL_FORM *window, *window_region, *window_sector, *window_view, *window_users;
extern FL_OBJECT *button_openRegion, *button_openSector, *button_openView, *button_openUser;
extern FL_OBJECT *button_closeRegion, *button_closeSector, *button_closeView;
extern FL_OBJECT *button_newuser, *button_connect, *button_disconnect, *button_quit;                   
extern FL_OBJECT *listbox_messages, *input_servermsg; 

extern FL_OBJECT *button_u_update, *button_u_close, *listbox_u_users;
extern FL_OBJECT *canvas_region, *canvas_sector, *canvas_view;

extern uint8 user_window_open, region_window_open, sector_window_open, view_window_open, redraw_needed;
extern uint32 view_x, view_y, view_w, view_h, view_zoom, view_zoom2, sector_x, sector_y;
extern int timeoutid_region, timeoutid_sector, timeoutid_view, timeout_value;
extern struct structObject *view_tracks_object;

extern XPoint xp_stars[50];

extern char *vz_text[9];

////////////////////////////////////////////////

void quit();

void openRegionWindow();
void openSectorWindow();
void openViewWindow();
void openUserWindow();    
void openNewUserWindow();

void closeRegionWindow();
void closeSectorWindow();
void closeViewWindow();
void closeUserWindow();

int exposeRegionWindow(FL_OBJECT *, Window, int, int, XEvent *, void *);
int exposeSectorWindow(FL_OBJECT *, Window, int, int, XEvent *, void *);
int exposeViewWindow(FL_OBJECT *, Window, int, int, XEvent *, void *);
int focusSectorWindow(FL_OBJECT *, Window, int, int, XEvent *, void *);
int focusViewWindow(FL_OBJECT *, Window, int, int, XEvent *, void *);
int dragViewWindow(FL_OBJECT *, Window, int, int, XEvent *, void *);
int releaseViewWindow(FL_OBJECT *, Window, int, int, XEvent *, void *);
int keyViewWindow(FL_OBJECT *, Window, int, int, XEvent *, void *);

void timerRegionWindow(int, void *);
void timerSectorWindow(int, void *);
void timerViewWindow(int, void *);
void redrawRegionWindow();
void redrawSectorWindow();
void redrawViewWindow(int, int);
void redrawUserWindow();

void processMessage();
void uiInit(int, char *[]);
void disableFormObject(FL_OBJECT *);
void enableFormObject(FL_OBJECT *);


#endif
