#include "global.h"

//////////////////////////////////////////////////////

pthread_t vm_thread;
int vm_dead, vm_shutdown;

//////////////////////////////////////////////////////

void serverShutdown(){
	FILE *timefile;
	char filename[120], in, data[BUFFER_SIZE];
	struct client_connection *client;
	int a;

	in = getchar();
//	if(in == 'q' || in == 'Q'){
		printf(":\tshutting down vm...\n");
		vm_shutdown = 1;

		// wait for VM to terminate before continuing.
		while(!vm_dead){ sleep(1); };

		printf(":\tupdating time file...\n");
		strcpy(filename, db_path);
		strcat(filename, "time");
		if((timefile=fopen(filename, "w")) == NULL){
			printf(":\tERROR: unable to create time file in %s\n", db_path);
			exit(EXIT_FAILURE);
		}
		fprintf(timefile, "compression=%d\nDO NOT EDIT CLOCK\nclock=%Ld", vm_time_compression, vm_time);
		fclose(timefile);

		// send DISCONNECT to all clients
		printf(":\tdisconnecting clients(%d)...\n", nr_clients);
		client = clients;
		sprintf(data, "%c", CMD__DISCONNECT);
		for(a=0; a<nr_clients; a++){
			clientSend(client->s, data);
			client = client->next;
		}

		// save objects, mapobjects, etc..
		printf(":\tsaving objects(%d)...\n", total_objects);
		objectSaveAll();

		exit(EXIT_SUCCESS);
//	}
}


int main(int argc, char *argv[]){
	FILE *timefile;
	char filename[120];

	if(argc<3 || argc>4){
		printf("Syntax: openspace_server port db_directory_path [time_resolution, default=5 [
			time_compression, default=1] ]\n\n");
		exit(EXIT_FAILURE);
	}

	// open database files
	strcpy(db_path, argv[2]);
	userLoadAll();
	objectLoadAll();
	shipclassLoadAll();

	// read time file
	strcpy(filename, db_path);
	strcat(filename, "time");
	if((timefile=fopen(filename, "r")) == NULL){
		if((timefile=fopen(filename, "w")) == NULL){
			printf(":\tunable to create time file in %s\n", db_path);
			exit(EXIT_FAILURE);
		}
		printf(":\ttime file not found, new time file created\n");
		vm_time_compression = 1;
		vm_time = 0;
		fprintf(timefile, "compression=%d\nDO NOT EDIT CLOCK\nclock=%Ld", vm_time_compression, vm_time);
	} else {
		fscanf(timefile, "compression=%d\nDO NOT EDIT CLOCK\nclock=%Ld", &vm_time_compression, &vm_time);
		if(vm_time_compression == 0){
			printf(":\ttime compression was ZERO, using normal time\n");
			vm_time_compression = 1;
		} else printf(":\tSET time compression = %d seconds per normal second\n", vm_time_compression);
	}
	fclose(timefile);
	printf(":\tSET openspace time = %Ld seconds\n", vm_time);

	if(argc==4) vm_time_resolution = atoi(argv[3]);
	else vm_time_resolution = 5;
	printf(":\tSET time resolution = %d seconds\n", vm_time_resolution);

	vm_dead = 0;
	vm_shutdown = 0;
	pthread_create(&vm_thread, NULL, vmStart, NULL);

//	setbuf(stdin, NULL);		// disable line buffering for stdin
	signal(SIGPIPE, SIG_IGN);
	signal(SIGINT, serverShutdown);
	clientListen(atoi(argv[1]));	// main process
	exit(EXIT_SUCCESS);
}
