#include "global.h"
#ifndef __NET_HEADER__
#define __NET_HEADER__

#define BUFFER_SIZE 1000

/////////////////////////////////////////////////

struct client_connection {
	struct sockaddr client;
	int s;
	time_t last_time;		// last time client sent data
	unsigned uid;
	unsigned graphics;		// none/2d/3d
	struct client_connection *next;
	struct client_connection *prev;
};
extern struct client_connection *clients;
extern int nr_clients;
extern pthread_mutex_t clients_mutex;

/////////////////////////////////////////////////

int				clientSend(int, char *);
int				clientRecv(int, char *);
void				clientListen(int);
int				clientLogin(int, struct sockaddr *, int *, struct sockaddr_in *, int *);
struct client_connection	*clientProcess(char *, struct client_connection *);
struct client_connection	*clientDisconnect(struct client_connection *);
struct client_connection	*clientIsOnline(unsigned);

#endif
