#include "vm.h"

//////////////////////////////////////////////

unsigned vm_time_resolution, vm_time_compression;
unsigned long long vm_time;

//////////////////////////////////////////////

void *vmStart(void *blah){
	time_t t1, t2;
	int sector, x, t;
	struct structObject *object;
	struct client_connection *client;
	char data[BUFFER_SIZE];

	printf(":\tvm started...\n");

	do{
		t1 = time(NULL);

		for(sector=0; sector<16; sector++){
		   object = object_db[sector];
		   for(x=0; x<nr_objects[sector]; x++){
			if(!(object->flags&1)){
			  if(object->velocity != 0){
				object->distance -= object->velocity * vm_time_compression * vm_time_resolution;
// the cos/sin of heading should also be precalculated and stored in object
				object->x += object->velocity * cos(object->heading);
				object->y -= object->velocity * sin(object->heading);
				object->heading += 0.785;
				if(object->heading > 6.3) object->heading -= 6.283;
#ifdef __DEBUG_SERVER_MOVE__
printf("OBJECT %s.move\t\tx=%u y=%u sector=%d\n", object->name, object->x, object->y, sector);
#endif
		//		transfer to new sector if needed

				if( (client = clientIsOnline(object->user_id)) != NULL ){
					sprintf(data, "%c%u %u %u %f", (char)CMD__UPDATE, object->id,
						object->x, object->y, object->heading);
					clientSend(client->s, data);
				}
			  }
			} else {
				object->flags&=1;
			}
			object = object->next;
		   }
		}

		// foreach(object in linked list)
		//	sector = object.sector
		//	R = square(object.max_scanner_range)
		//	if(R crosses the sector) repeat for each crossed sector
		//	foreach(object in sector)
		//		D = (x2-x1)^2 + (y2-y1)^2
		//		if(R > D) object can be seen
		//			if(user == UNSEEN) send(SEEN, user)
		//			send(owner, OBJECT, ...)
		//			foreach(ally) send(ally, OBJECT, ...)
		//		objectProcessTriggers(object)


		t2 = time(NULL);
		t = t2 - t1;
		if(t > vm_time_resolution){
			printf("AI: overload=%d, increase the time resolution or kill some processes\n", t);
		} else sleep(vm_time_resolution - t);

		vm_time += vm_time_resolution * vm_time_compression;
		printf("OpenSpace time = %Ld seconds\n", vm_time);

	}while(!vm_shutdown);
	printf(":\tvm terminated\n");
	vm_dead = 1;
	return(NULL);
}
